Package com.enonic.xp.node

## Interface NodeService

-     @PublicApi
      public interface NodeService

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Deprecated Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `ApplyNodePermissionsResult` | `applyPermissions​(ApplyNodePermissionsParams params)` |
    `NodeCommitEntry` | `commit​(NodeCommitEntry nodeCommitEntry, NodeIds nodeIds)` |
    `NodeCommitEntry` | `commit​(NodeCommitEntry nodeCommitEntry, RoutableNodeVersionIds routableNodeVersionIds)` |
    `NodeComparison` | `compare​(NodeId id, Branch target)` |
    `NodeComparisons` | `compare​(NodeIds ids, Branch target)` |
    `Node` | `create​(CreateNodeParams params)` |
    `Node` | `createRootNode​(CreateRootNodeParams params)` | Deprecated.
    `DeleteNodeResult` | `delete​(DeleteNodeParams deleteNodeParams)` |
    `NodeIds` | `deleteById​(NodeId id)` | Deprecated.
    `NodeIds` | `deleteById​(NodeId id, DeleteNodeListener deleteListener)` | Deprecated.
    `NodeIds` | `deleteByPath​(NodePath path)` | Deprecated.
    `boolean` | `deleteVersion​(NodeId nodeId, NodeVersionId nodeVersionId)` | Deprecated.
    `Node` | `duplicate​(DuplicateNodeParams params)` |
    `FindNodesByParentResult` | `findByParent​(FindNodesByParentParams params)` |
    `FindNodesByMultiRepoQueryResult` | `findByQuery​(MultiRepoNodeQuery nodeQuery)` |
    `FindNodesByQueryResult` | `findByQuery​(NodeQuery nodeQuery)` |
    `NodeCommitQueryResult` | `findCommits​(NodeCommitQuery nodeCommitQuery)` |
    `FindNodePathsByQueryResult` | `findNodePathsByQuery​(NodeQuery nodeQuery)` | Deprecated.
    `NodeVersionQueryResult` | `findVersions​(GetNodeVersionsParams params)` |
    `NodeVersionQueryResult` | `findVersions​(NodeVersionQuery nodeVersionQuery)` |
    `GetActiveNodeVersionsResult` | `getActiveVersions​(GetActiveNodeVersionsParams params)` |
    `ByteSource` | `getBinary​(NodeId nodeId, NodeVersionId nodeVersionId, BinaryReference reference)` |
    `ByteSource` | `getBinary​(NodeId nodeId, BinaryReference reference)` |
    `String` | `getBinaryKey​(NodeId nodeId, BinaryReference reference)` |
    `Node` | `getById​(NodeId id)` |
    `Node` | `getByIdAndVersionId​(NodeId id, NodeVersionId versionId)` |
    `Nodes` | `getByIds​(NodeIds ids)` |
    `NodeVersion` | `getByNodeVersionKey​(NodeVersionKey nodeVersionKey)` |
    `Node` | `getByPath​(NodePath path)` |
    `Node` | `getByPathAndVersionId​(NodePath path, NodeVersionId versionId)` | Deprecated.
    `Nodes` | `getByPaths​(NodePaths paths)` |
    `NodeCommitEntry` | `getCommit​(NodeCommitId nodeCommitId)` |
    `Node` | `getRoot()` |
    `boolean` | `hasChildren​(Node node)` |
    `NodesHasChildrenResult` | `hasChildren​(Nodes nodes)` | Deprecated.
    `boolean` | `hasUnpublishedChildren​(NodeId parent, Branch target)` |
    `ImportNodeResult` | `importNode​(ImportNodeParams params)` |
    `void` | `importNodeCommit​(ImportNodeCommitParams params)` |
    `void` | `importNodeVersion​(ImportNodeVersionParams params)` |
    `LoadNodeResult` | `loadNode​(LoadNodeParams params)` |
    `Node` | `move​(MoveNodeParams params)` |
    `Node` | `move​(NodeId nodeId, NodePath parentNodePath, MoveNodeListener moveListener)` | Deprecated.
    `Nodes` | `move​(NodeIds nodeIds, NodePath parentNodePath, MoveNodeListener moveListener)` | Deprecated.
    `boolean` | `nodeExists​(NodeId nodeId)` |
    `boolean` | `nodeExists​(NodePath nodePath)` |
    `PushNodesResult` | `push​(NodeIds ids, Branch target)` |
    `PushNodesResult` | `push​(NodeIds ids, Branch target, PushNodesListener pushListener)` |
    `void` | `refresh​(RefreshMode refreshMode)` |
    `Node` | `rename​(RenameNodeParams params)` |
    `ReorderChildNodesResult` | `reorderChildren​(ReorderChildNodesParams params)` |
    `ResolveSyncWorkResult` | `resolveSyncWork​(SyncWorkResolverParams params)` |
    `NodeVersionId` | `setActiveVersion​(NodeId nodeId, NodeVersionId nodeVersionId)` |
    `Node` | `setChildOrder​(SetNodeChildOrderParams params)` |
    `SetNodeStateResult` | `setNodeState​(SetNodeStateParams params)` | Deprecated.
    `Node` | `setRootPermissions​(AccessControlList accessControlList, boolean inheritPermissions)` |
    `Node` | `update​(UpdateNodeParams params)` |

- - ### Method Detail

    - #### create

          Node create​(CreateNodeParams params)

    - #### update

          Node update​(UpdateNodeParams params)

    - #### rename

          Node rename​(RenameNodeParams params)

    - #### push

          PushNodesResult push​(NodeIds ids,
                               Branch target)

    - #### push

          PushNodesResult push​(NodeIds ids,
                               Branch target,
                               PushNodesListener pushListener)

    - #### deleteById

          @Deprecated
          NodeIds deleteById​(NodeId id)

      Deprecated.

    - #### deleteById

          @Deprecated
          NodeIds deleteById​(NodeId id,
                             DeleteNodeListener deleteListener)

      Deprecated.

    - #### deleteByPath

          @Deprecated
          NodeIds deleteByPath​(NodePath path)

      Deprecated.

    - #### delete

          DeleteNodeResult delete​(DeleteNodeParams deleteNodeParams)

    - #### getById

          Node getById​(NodeId id)

    - #### getByIdAndVersionId

          Node getByIdAndVersionId​(NodeId id,
                                   NodeVersionId versionId)

    - #### getByIds

          Nodes getByIds​(NodeIds ids)

    - #### getByPath

          Node getByPath​(NodePath path)

    - #### getByPathAndVersionId

          @Deprecated
          Node getByPathAndVersionId​(NodePath path,
                                     NodeVersionId versionId)

      Deprecated.

    - #### getByPaths

          Nodes getByPaths​(NodePaths paths)

    - #### duplicate

          Node duplicate​(DuplicateNodeParams params)

    - #### move

          @Deprecated
          Node move​(NodeId nodeId,
                    NodePath parentNodePath,
                    MoveNodeListener moveListener)

      Deprecated.

    - #### move

          Node move​(MoveNodeParams params)

    - #### move

          @Deprecated
          Nodes move​(NodeIds nodeIds,
                     NodePath parentNodePath,
                     MoveNodeListener moveListener)

      Deprecated.

    - #### findByParent

          FindNodesByParentResult findByParent​(FindNodesByParentParams params)

    - #### findByQuery

          FindNodesByQueryResult findByQuery​(NodeQuery nodeQuery)

    - #### findNodePathsByQuery

          @Deprecated
          FindNodePathsByQueryResult findNodePathsByQuery​(NodeQuery nodeQuery)

      Deprecated.

    - #### findByQuery

          FindNodesByMultiRepoQueryResult findByQuery​(MultiRepoNodeQuery nodeQuery)

    - #### compare

          NodeComparison compare​(NodeId id,
                                 Branch target)

    - #### compare

          NodeComparisons compare​(NodeIds ids,
                                  Branch target)

    - #### findVersions

          NodeVersionQueryResult findVersions​(GetNodeVersionsParams params)

    - #### findVersions

          NodeVersionQueryResult findVersions​(NodeVersionQuery nodeVersionQuery)

    - #### findCommits

          NodeCommitQueryResult findCommits​(NodeCommitQuery nodeCommitQuery)

    - #### deleteVersion

          @Deprecated
          boolean deleteVersion​(NodeId nodeId,
                                NodeVersionId nodeVersionId)

      Deprecated.

    - #### getActiveVersions

          GetActiveNodeVersionsResult getActiveVersions​(GetActiveNodeVersionsParams params)

    - #### setActiveVersion

          NodeVersionId setActiveVersion​(NodeId nodeId,
                                         NodeVersionId nodeVersionId)

    - #### setChildOrder

          Node setChildOrder​(SetNodeChildOrderParams params)

    - #### reorderChildren

          ReorderChildNodesResult reorderChildren​(ReorderChildNodesParams params)

    - #### getByNodeVersionKey

          NodeVersion getByNodeVersionKey​(NodeVersionKey nodeVersionKey)

    - #### resolveSyncWork

          ResolveSyncWorkResult resolveSyncWork​(SyncWorkResolverParams params)

    - #### refresh

          void refresh​(RefreshMode refreshMode)

    - #### applyPermissions

          ApplyNodePermissionsResult applyPermissions​(ApplyNodePermissionsParams params)

    - #### getBinary

          ByteSource getBinary​(NodeId nodeId,
                               BinaryReference reference)

    - #### getBinary

          ByteSource getBinary​(NodeId nodeId,
                               NodeVersionId nodeVersionId,
                               BinaryReference reference)

    - #### getBinaryKey

          String getBinaryKey​(NodeId nodeId,
                              BinaryReference reference)

    - #### createRootNode

          @Deprecated
          Node createRootNode​(CreateRootNodeParams params)

      Deprecated.

    - #### setNodeState

          @Deprecated
          SetNodeStateResult setNodeState​(SetNodeStateParams params)

      Deprecated.

    - #### getRoot

          Node getRoot()

    - #### setRootPermissions

          Node setRootPermissions​(AccessControlList accessControlList,
                                  boolean inheritPermissions)

    - #### importNode

          ImportNodeResult importNode​(ImportNodeParams params)

    - #### loadNode

          LoadNodeResult loadNode​(LoadNodeParams params)

    - #### hasChildren

          @Deprecated
          NodesHasChildrenResult hasChildren​(Nodes nodes)

      Deprecated.

    - #### commit

          NodeCommitEntry commit​(NodeCommitEntry nodeCommitEntry,
                                 RoutableNodeVersionIds routableNodeVersionIds)

    - #### commit

          NodeCommitEntry commit​(NodeCommitEntry nodeCommitEntry,
                                 NodeIds nodeIds)

    - #### getCommit

          NodeCommitEntry getCommit​(NodeCommitId nodeCommitId)

    - #### hasChildren

          boolean hasChildren​(Node node)

    - #### nodeExists

          boolean nodeExists​(NodeId nodeId)

    - #### nodeExists

          boolean nodeExists​(NodePath nodePath)

    - #### hasUnpublishedChildren

          boolean hasUnpublishedChildren​(NodeId parent,
                                         Branch target)

    - #### importNodeVersion

          void importNodeVersion​(ImportNodeVersionParams params)

    - #### importNodeCommit

          void importNodeCommit​(ImportNodeCommitParams params)